"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _assign = require("babel-runtime/core-js/object/assign");

var _assign2 = _interopRequireDefault(_assign);

exports.md = md;
exports.yaml = yaml;

var _jsYaml = require("js-yaml");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function md(str) {
  var obj = {};
  var front = str.match(/---([\s\S]*?)---/);
  if (front) {
    (0, _assign2.default)(obj, (0, _jsYaml.safeLoad)(front[1]));
    obj.body = str.replace(front[0], "").trim();
  } else {
    obj.body = str.trim();
  }
  return obj;
}

function yaml(str) {
  return (0, _jsYaml.safeLoad)(str);
}

exports.default = {
  md: md,
  yaml: yaml
};