"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _freeze = require("babel-runtime/core-js/object/freeze");

var _freeze2 = _interopRequireDefault(_freeze);

var _create = require("babel-runtime/core-js/object/create");

var _create2 = _interopRequireDefault(_create);

exports.default = function () {

  return function catalyze(node, parent, root) {

    var self = (0, _create2.default)(Object.prototype, node.data);
    if (parent) {
      if (parent.inheritance) {
        self = (0, _create2.default)(parent.inheritance, node.data);
      }
      Object.defineProperty(self, "parent", { value: parent });
    }

    if (!root) {
      root = self;
    }
    Object.defineProperty(self, "root", { value: root });

    if (node.inheritance) {
      var inheritance = (0, _create2.default)(Object.prototype, node.inheritance);
      Object.defineProperty(self, "inheritance", { value: inheritance });
    }

    if (node.children) {
      var children = node.children.reduce(function (all, obj) {
        all[obj.data.slug.value] = catalyze(obj, self, root);
        return all;
      }, {});
      Object.defineProperty(self, "children", { value: (0, _freeze2.default)(children) });
    }

    return self;
  };
};

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }